CON
	_xinfreq		= 5_000_000		' Quartz is 5MHz
	_clkmode		= xtal1 + pll16x	' System clock is 80MHz

	FONT_H			= 8
	extra

	VideoPLL16X		= 15

VAR
	long	cog

PUB start(video_pin) : okay
	okay := cog := cognew(@entry, video_pin)

PUB stop
	if cog
		cogstop(cog~~ - 1)
DAT
		org	0

entry		mov	vpin, par			' get video pin
		shr	vpin, #3			' convert into video pin group

		'               vmode      cmode    chroma1  chroma0  auralsub
		mov	xvcfg, #(%01<<6) | (1<<5) | (0<<4) | (0<<3) | %000
		shl	xvcfg, #(23 - 9)
		or	xvcfg, vpin			' or with video pin group
		shl	xvcfg, #9
		or	xvcfg, #%11111111		' all 8 pins
		shl	vpin, #3			' vpin * 8
		mov	xdira, #%11111111		' 8 pins
		shl	xdira, vpin			' shift to group position
		mov	dira, xdira
		mov	outa, #0

		movi	ctra, #VideoPLL16X		' Setup for 205 MHz counter output
		movd	ctra, #0
		movs	ctra, #0
		mov	frqa, xfrqa
		mov	vscl, xvscl			' Setup video scale; Pixel clock = 205 MHz / 10 = 22.5 MHz

		mov	vcfg, xvcfg

frame		mov	mem_ptr, vgamem_ptr
		mov	pal_ptr, palette_ptr
		mov	lines, #240 / FONT_H		' 240 scan lines / scan rows per character

:char_row	mov	pal_line, #FONT_H		' for each character scan row

:scan_line	waitvid	HSYNC, #0			' hsync
		waitvid	HSYNC, #0
		waitvid	HSYNC, #0
		waitvid	PORCH, #0			' horizontal front porch
		waitvid	PORCH, #0			' horizontal front porch

		mov	temp, #160/4
:columns1	rdlong	cur_pal, pal_ptr
		add	pal_ptr, #4
		rdlong	points, mem_ptr
		add	mem_ptr, #4
		waitvid	cur_pal, points
		djnz	temp, #:columns1

		sub	mem_ptr, #160			' same memory again
		sub	pal_ptr, #160			' same palette again

		waitvid	HSYNC, #0
		waitvid	HSYNC, #0
		waitvid	HSYNC, #0
		waitvid	PORCH, #0			' horizontal front porch
		waitvid	PORCH, #0			' horizontal front porch

		mov	temp, #160/4
:columns2	rdlong	cur_pal, pal_ptr
		rdlong	points, mem_ptr
		add	mem_ptr,#4
		add	pal_ptr, #4
		waitvid	cur_pal, points
		djnz	temp,#:columns2

		sub	pal_ptr, #160			' same palette again
		djnz	pal_line, #:scan_line
		add	pal_ptr, #160			' next character row palettes

		cmp	mem_ptr, palette_ptr	WZ
	if_z	mov	mem_ptr, vgamem_ptr
	if_z	mov	pal_ptr, palette_ptr

		djnz	lines, #:char_row

		mov	lines, #11			' vertical bottom porch lines = 11
:blank1_rows	waitvid	HSYNC, #0
		waitvid	HSYNC, #0
		waitvid	HSYNC, #0
		waitvid	PORCH, #0
		waitvid	PORCH, #0
		mov	temp, #160/4			' 41 * 16 pixels
:blank1_cols	waitvid	PORCH, #0
		djnz	temp,#:blank1_cols
		djnz	lines,#:blank1_rows

		mov	lines, #2			' vertical sync lines = 2
:vsync_rows	waitvid	V_HSYNC, #0
		waitvid	V_HSYNC, #0
		waitvid	V_HSYNC, #0
		waitvid	V_PORCH, #0
		waitvid	V_PORCH, #0
		mov	temp, #160/4			' 41 * 16 pixels
:vsync_cols	waitvid	V_PORCH, #0
		djnz	temp, #:vsync_cols
		djnz	lines, #:vsync_rows

		mov	lines, #31			' vertical front port lines = 31
:blank2_rows	waitvid	HSYNC, #0
		waitvid	HSYNC, #0
		waitvid	HSYNC, #0
		waitvid	PORCH, #0
		waitvid	PORCH, #0
		mov	temp, #160/4			' 41 * 16 pixels
:blank2_cols	waitvid	PORCH, #0
		djnz	temp, #:blank2_cols
		djnz	lines, #:blank2_rows

		jmp	 #frame

'**********************************************************************
xdira		long	0
xvcfg		long	0
xvscl		long	(10 << 12) | (10 * 16)		' 10 PLL clocks per pixel, 160 PLL clocks per frame of 16 pixels
xfrqa		long	43 << 24			' 215 MHz

vgamem_ptr	long	@@@vgamem_0
palette_ptr	long	@@@palette_0

PORCH		long	$03
V_PORCH		long	$02
HSYNC		long	$01
V_HSYNC		long	$00

vpin		res	1
lines		res	1
pal_line	res	1
temp		res	1
mem_ptr		res	1
points		res	1
pal_ptr		res	1
cur_pal		res	1

		fit	$1f0

vgamem_0	long	$aa3300ff[160/4*FONT_H]
vgamem_1	long	$55cc6699[160/4*FONT_H]
palette_0	long	$13233343[160/4]
palette_1	long	$e3d3c3b3[160/4]
